// Generated by CoffeeScript 2.1.1
var _byTag, _isArray, _isPlainObject, createFileWriter, exports, formatML, fs, moment, path, util;

path = require('path');

fs = require('fs');

util = require('util');

moment = require('moment');

_isArray = Array.isArray || function(obj) {
  return Object.prototype.toString.call(obj) === "[object Array]";
};

_isPlainObject = function(obj) {
  return obj !== null && typeof obj === 'object' && Object.getPrototypeOf(obj) === Object.prototype;
};

formatML = function(ml) {
  var _str;
  _str = function(ml_node) {
    var attr, child_start_inx, child_txts, tag;
    // txts = []
    tag = ml_node[0];
    attr = null;
    child_start_inx = 1;
    if (_isPlainObject(ml_node[child_start_inx])) {
      attr = ml_node[1];
      child_start_inx++;
    }
    child_txts = ml_node.slice(child_start_inx).map(function(child) {
      if (_isArray(child)) {
        return _str(child);
      }
      return child;
    });
    return _byTag(tag, attr, child_txts);
  };
  // txts.join ' '
  return _str(ml);
};

_byTag = function(tag, attr, child_txts) {
  if (formatML[tag]) {
    return formatML[tag](tag, attr, child_txts);
  }
  return child_txts.join(' ');
};

formatML.text = function(tag, attr, child_txts) {
  var str;
  str = child_txts.join(' ');
  if (attr) {
    str = `[${str}](${JSON.stringify(attr)})`;
  }
  return str;
};

formatML.who = function(tag, attr, child_txts) {
  return '[' + child_txts.join(':') + ']';
};

formatML.testimony = formatML.log_stmt = function(tag, attr, child_txts) {
  var dt, time, words;
  time = moment(attr.when);
  dt = time.format("hh:mm:ss.SSSS");
  words = [];
  words.push(`[${dt}]`);
  words.push("PID=", attr.pid);
  words.push(...child_txts);
  return words.join(' ') + '\n';
};

formatML.dump = function(tag, attr, child_txts) {
  var str;
  str = '\n';
  str += attr.name + ' => ';
  str += child_txts.join('\n');
  return str;
};

createFileWriter = function(conf = {}) {
  var _appendToFile, _formatLog, _getFilepath, _writer, bufLogs, lock, truncated;
  truncated = false;
  lock = false;
  bufLogs = [];
  _formatLog = function(...log_args) {
    var strs;
    if (Array.isArray(log_args[0])) {
      return formatML(log_args[0]);
    }
    strs = log_args.map(function(x) {
      return x.toString();
    });
    return strs.join(' ') + '\n';
  };
  _getFilepath = function(file_ymd) {
    return path.join(conf.dir, `${file_ymd}` + conf.postfix);
  };
  _appendToFile = function() {
    var attrs, data_to_fs, el_type, els, file_ymd, filepath, log_args, time, ymd;
    if (lock) {
      return;
    }
    if (bufLogs.length === 0) {
      return;
    }
    lock = true;
    data_to_fs = '';
    file_ymd = null;
    while (true) {
      if (bufLogs.length === 0) {
        break;
      }
      log_args = bufLogs[0];
      if (Array.isArray(log_args[0])) {
        // JsonML
        // console.log 'log_args[0]', log_args[0]
        [el_type, attrs, ...els] = log_args[0];
        time = moment(attrs.when);
        ymd = time.format("YYYYMMDD");
      } else {
        ymd = moment().format("YYYYMMDD");
      }
      if (file_ymd !== null && file_ymd !== ymd) {
        break; // 추출한 것까지 저장하고 다음 파일로감
      }
      file_ymd = ymd;
      bufLogs.shift();
      data_to_fs += _formatLog(...log_args);
    }
    filepath = _getFilepath(file_ymd);
    return fs.appendFile(filepath, data_to_fs, function(err) {
      lock = false;
      return _appendToFile();
    });
  };
  return _writer = function(...log_args) {
    bufLogs.push(log_args);
    return _appendToFile();
  };
};

createFileWriter.formatML = formatML;

module.exports = exports = createFileWriter;
