// Generated by CoffeeScript 2.1.1

/*

Json ML 규격으로 하자. 그래야 Stream너머로 보내기에 유리함.

입력 가능은..
  1. Strings... 
  2. JsonML
  3. Class Instance..? (이거 너무 의존적.. ) 그러니 JsonML로..

*/
var EpicLog, _isString, exports, filter_factory, writer_factory, writers,
  hasProp = {}.hasOwnProperty;

_isString = function(obj) {
  return typeof obj === 'string' || obj instanceof String;
};

writers = {};

EpicLog = function(...log_args) {
  var _write_fn, attrs, els, filter_fn, json_ml, k, results, tag;
  attrs = null;
  if (Array.isArray(log_args[0])) {
    json_ml = log_args[0];
    [tag, attrs, ...els] = json_ml;
  }
  results = [];
  for (k in writers) {
    if (!hasProp.call(writers, k)) continue;
    [filter_fn, _write_fn] = writers[k];
    if (attrs && filter_fn) {
      if (true !== filter_fn(attrs)) {
        continue;
      }
    }
    results.push(_write_fn(...log_args));
  }
  return results;
};

writer_factory = {};

EpicLog.addWriterFactory = function(key, factory_fn) {
  writer_factory[key] = factory_fn;
  if (!factory_fn) {
    return delete writer_factory[key];
  }
};

EpicLog.createWriter = function(key, conf) {
  return writer_factory[key](conf);
};

filter_factory = {};

EpicLog.addFilterFactory = function(key, factory_fn) {
  return filter_factory[key] = factory_fn;
};

EpicLog.setWriter = function(key, filter_fn, sub_writer) {
  writers[key] = [filter_fn, sub_writer];
  if (!sub_writer) {
    return delete writers[key];
  }
};

EpicLog.getWriter = function(key) {
  return writers[key][1];
};

EpicLog.getWriterKeys = function() {
  return Object.keys(writers);
};

EpicLog.getFilterConf = function(key) {
  return writers[key][0];
};

EpicLog.addWriterFactory('vt', require('./vt-writer'));

EpicLog.addWriterFactory('file', require('./file-writer'));

module.exports = exports = EpicLog;
