// Generated by CoffeeScript 2.1.1
var _byTag, _isArray, _isPlainObject, asigned_colored, chalk, color_candidates, colored, createVTWriter, exports, formatML, moment, next_asigned_index, shuffleArray;

moment = require('moment');

//####################################################################
// Console
shuffleArray = function(a) {
  var i, j, x;
  i = a.length;
  while (i) {
    j = Math.floor(Math.random() * i);
    x = a[i - 1];
    a[i - 1] = a[j];
    a[j] = x;
    i--;
  }
  return a;
};

_isArray = Array.isArray || function(obj) {
  return Object.prototype.toString.call(obj) === "[object Array]";
};

_isPlainObject = function(obj) {
  return obj !== null && typeof obj === 'object' && Object.getPrototypeOf(obj) === Object.prototype;
};

chalk = require('chalk');

color_candidates = "red,green,yellow,blue,magenta,cyan"; // ,redBright,greenBright,yellowBright,blueBright,magentaBright,cyanBright"

color_candidates = shuffleArray(color_candidates.split(','));

next_asigned_index = 0;

asigned_colored = {};

colored = function(section) {
  var clr;
  if (!asigned_colored[section]) {
    asigned_colored[section] = color_candidates[next_asigned_index];
    next_asigned_index++;
    if (next_asigned_index === color_candidates.length) {
      next_asigned_index = 0;
    }
  }
  clr = asigned_colored[section];
  // console.log 'clr=', clr
  return chalk.bold[clr](section);
};

formatML = function(ml) {
  var _str;
  _str = function(ml_node) {
    var attr, child_start_inx, child_txts, tag;
    // txts = []
    tag = ml_node[0];
    attr = null;
    child_start_inx = 1;
    if (_isPlainObject(ml_node[child_start_inx])) {
      attr = ml_node[1];
      child_start_inx++;
    }
    child_txts = ml_node.slice(child_start_inx).map(function(child) {
      if (_isArray(child)) {
        return _str(child);
      }
      return child;
    });
    // _byTag tag, attr, child_txts
    if (formatML[tag]) {
      return formatML[tag](tag, attr, child_txts);
    }
    return child_txts.join(' ');
  };
  return _str(ml);
};

_byTag = function(tag, attr, child_txts) {
  if (formatML[tag]) {
    return formatML[tag](tag, attr, child_txts);
  }
  return child_txts.join(' ');
};

formatML.testimony = formatML.log_stmt = function(tag, attr, child_txts) {
  var dt, time, words;
  time = moment(attr.when);
  dt = time.format("hh:mm:ss.SSSS");
  words = [];
  words.push(`[${dt}]`);
  words.push(chalk.cyan(attr.pid));
  words.push(...child_txts);
  return words.join(' ');
};

formatML.who = function(tag, attr, child_txts) {
  child_txts = child_txts.map(function(str) {
    return colored(str);
  });
  return '[' + child_txts.join(':') + ']';
};

formatML.id = function(tag, attr, child_txts) {
  var str, toks;
  str = child_txts[0];
  toks = str.split(':').map(function(t) {
    return colored(t);
  });
  return toks.join(":");
};

// child_txts = child_txts.map (str)-> colored str
// return child_txts.join(':')
formatML.variable = function(tag, attr, child_txts) {
  var str;
  str = child_txts[0];
  return colored(str);
};

// toks = str.split(':').map (t)-> colored t
// return "@" + toks.join ":"
formatML.text = function(tag, attr, child_txts) {
  var str;
  str = child_txts.join(' ');
  if (attr.color) {
    str = chalk[attr.color](str);
  }
  // str = "[#{str}](#{JSON.stringify attr })"
  return str;
};

formatML.dump = function(tag, attr, child_txts) {
  var body, str;
  str = '\n';
  str += chalk.cyan(attr.name) + ' => ';
  body = child_txts.join('\n');
  if (attr.type === 'error') {
    body = chalk.red(body);
  }
  str += body;
  return str;
};

createVTWriter = function(conf = {}) {
  var _writer;
  return _writer = function(...log_args) {
    var words;
    if (Array.isArray(log_args[0])) {
      return console.log(formatML(log_args[0]));
    } else {
      words = log_args.map(function(x) {
        return x.toString();
      });
      return console.log(words.join(' '));
    }
  };
};

createVTWriter.formatML = formatML;

module.exports = exports = createVTWriter;
